import sys

fi = file(sys.argv[1],'r')
fo = file(sys.argv[2],'w')

fo.write('<?xml version="1.0" encoding="ISO-8859-1"?>\n')

gap = 0
bpm = 0
insong = False
firstsent = True

curt = 0

for line in fi.readlines():
    if line[0] == '#':
        if line[:5] == '#BPM:':
            s = line[5:]
            if s[-1] == '\n':
                s = s[:-1]
            s = s.replace(',','.')
            bpm = float(s)/2.
            fo.write('<MELODY Version="1" Tempo="%s" Resolution="Demisemiquaver" FixedTempo="Yes" Genre="Rock" Year="2008">\n\n' % str(bpm))
        elif line[:5] == '#GAP:':
            gap = int(float(line[5:].replace(',','.'))*bpm/7500.0)
        elif line[:7] == '#TITLE:':
            fo.write('\n	<!-- Title:   %s -->\n' % line[7:-1])
        elif line[:8] == '#ARTIST:':
            fo.write('	<!-- Artist:   %s -->\n\n' % line[8:-1])							
    elif line[0] == ':':
        if firstsent:
            fo.write('		<SENTENCE>\n')
            if insong:
                fo.write('			<LABEL Name="Bar Marker" Delay="%d"></LABEL>\n' % gap)
            else:
                fo.write('			<LABEL Name="Bar Marker" Delay="30"></LABEL>\n')
                fo.write('			<NOTE MidiNote="0" Duration="%s" Lyric="" ></NOTE>\n' % str(gap))
            firstsent = False
        s = line.split(' ')
        n = int(float(s[1].replace(',','.')))
        d = int(float(s[2].replace(',','.')))
        m = int(float(s[3].replace(',','.')))
        p = s[4]
        if p == '' and len(s) > 4:
            p = s[5]
        if p != '':
            if p[-1] == '\n':
                p = p[:-1]
        if p != '':
            if p[-1] == '\r':
                p = p[:-1]
        if n != curt:
            fo.write('			<NOTE MidiNote="0" Duration="%d" Lyric=""></NOTE>\n' % (n-curt))
            curt = n
        fo.write('			<NOTE MidiNote="%s" Duration="%s" Lyric="%s"></NOTE>\n' % (str(m), str(d), p))
        curt += d
    elif line[0] == '*':
        if firstsent:
            fo.write('		<SENTENCE>\n')
            if insong:
                fo.write('			<LABEL Name="Bar Marker" Delay="%d"></LABEL>\n' % gap)
            else:
                fo.write('			<LABEL Name="Bar Marker" Delay="30"></LABEL>\n')
                fo.write('			<NOTE MidiNote="0" Duration="%s" Lyric="" ></NOTE>\n' % str(gap))
            firstsent = False
        s = line.split(' ')
        n = int(float(s[1].replace(',','.')))
        d = int(float(s[2].replace(',','.')))
        m = int(float(s[3].replace(',','.')))
        p = s[4]
        if p == '' and len(s) > 4:
            p = s[5]
        if p != '':
            if p[-1] == '\n':
                p = p[:-1]
        if p != '':
            if p[-1] == '\r':
                p = p[:-1]
        if n != curt:
            fo.write('			<NOTE MidiNote="0" Duration="%d" Lyric="" Bonus="Yes"></NOTE>\n' % (n-curt))
            curt = n
        fo.write('			<NOTE MidiNote="%s" Duration="%s" Lyric="%s" Bonus="Yes"></NOTE>\n' % (str(m), str(d), p))
        curt += d
    elif line[0] == 'F':
        if firstsent:
            fo.write('		<SENTENCE>\n')
            if insong:
                fo.write('			<LABEL Name="Bar Marker" Delay="%d"></LABEL>\n' % gap)
            else:
                fo.write('			<LABEL Name="Bar Marker" Delay="30"></LABEL>\n')
                fo.write('			<NOTE MidiNote="0" Duration="%s" Lyric=""  FreeStyle="Yes"></NOTE>\n' % str(gap))
            firstsent = False
        s = line.split(' ')
        n = int(float(s[1].replace(',','.')))
        d = int(float(s[2].replace(',','.')))
        m = int(float(s[3].replace(',','.')))
        p = s[4]
        if p == '' and len(s) > 4:
            p = s[5]
        if p != '':
            if p[-1] == '\n':
                p = p[:-1]
        if p != '':
            if p[-1] == '\r':
                p = p[:-1]
        if n != curt:
            fo.write('			<NOTE MidiNote="0" Duration="%d" Lyric="" FreeStyle="Yes"></NOTE>\n' % (n-curt))
            curt = n
        fo.write('			<NOTE MidiNote="%s" Duration="%s" Lyric="%s" FreeStyle="Yes"></NOTE>\n' % (str(m), str(d), p))
        curt += d
    elif line[0] == '-':
        s = line.split(' ')
        if len(s) == 1:
            gap = int(line[1:])
        else:
            gap = int(s[1])
        firstsent = True
        insong = True
        fo.write('		</SENTENCE>\n\n')
    elif line[0] == 'E':
        fo.write('		</SENTENCE>\n\n')
        break
fo.write('		<SENTENCE>\n			<NOTE MidiNote="0" Duration="%s" Lyric=""></NOTE>\n		</SENTENCE>\n\n</MELODY>\n' % str(int(0.666*bpm)))
fo.close()
fi.close()
